<?php
/**
 * Created by PhpStorm.
 * User: gabriel
 * Date: 28/11/17
 * Time: 18:00
 */

namespace Shopbydedi\Model;

use Payplug\Resource\PaymentCard;


class CardModel implements SaveCard
{
    /**
     * @var \Site_SQL
     */
    protected $sql;

    public function __construct()
    {
        $this->sql = new \Site_SQL();
    }

    public function add($clientId, PaymentCard $card, $name = '')
    {
        if (
            empty($clientId)
            || empty($card)
            || empty($card->last4)
            || empty($card->id)
        ) {
            return false;
        }

        if (empty($name)) {
            $name = $card->brand;
        }

        $sql = "INSERT INTO client_payplug (client_payplug_cb_hint, client_payplug_key, client_payplug_nom, client_id, client_payplug_brand)";
        $sql .= " VALUES ('xxxx{$card->last4}', '{$card->id}', '$name', $clientId, '{$card->brand}')";

        $this->sql->query($sql);
        return $this->sql->lastId;
    }

    public function get($clientId, $cardId = null)
    {
        if (empty($clientId) && !empty($cardId)) {
            return false;// obviously you dont want anybody to be able to use any cb
        }

        $sql = "SELECT * FROM client_payplug WHERE 1";
        $sql .= " AND client_id = $clientId";

        if (!empty($cardId)) {
            $sql .= " AND client_payplug_id = $cardId";
        }

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        return $this->sql->record;
    }

    public function delete($clientId, $cardId)
    {
        if (empty($clientId) || empty($cardId)) {
            return false;
        }

        $sql = "DELETE FROM client_payplug WHERE client_id = $clientId AND client_payplug_id = $cardId";

        return $this->sql->query($sql);
    }
}